# Schlumberger
# Copyright 2019 Schlumberger.  All rights reserved in Schlumberger authored and generated code (including the selection and arrangement of the source code base regardless of the authorship of individual files), but not including any copyright interest(s) owned by a third party related to source code or object code authored or generated by non-Schlumberger personnel.
# This source code includes Schlumberger confidential and/or proprietary information and may include Schlumberger trade secrets.  Any use, disclosure and/or reproduction is prohibited unless authorized in writing.
#

from pyspark.sql import SparkSession
from pyspark import SparkConf
from pyspark.sql import SQLContext
from gcloud import storage
import os.path
from pathlib import Path
import os
import itertools
import pandas as pa
from pandas.api.types import is_numeric_dtype
import numpy as np
import time
import argparse
import aiohttp
import time
import random
import asyncio
import argparse
import datetime
import lasio
from pyspark.sql.types import IntegerType, DoubleType, StringType, StructType, StructField
import pathlib
import string


if __name__ == "__main__":
    print(f"#| CURVE COUNT - start")

    parser = argparse.ArgumentParser()
    parser.add_argument("--bucketname")
    parser.add_argument("--blobprefix")
    parser.add_argument("--gcsaccount")
  
    args= parser.parse_args()
    bucketname=args.bucketname
    blobprefix=args.blobprefix
    gcsaccount = args.gcsaccount
    # hpda-gcs-mptc-external-1-hpdaext1.json
  
    print(f"#| bucketname={bucketname}")
    print(f"#| blobprefix={blobprefix}")
    print(f"#| gcsaccount={gcsaccount}")
 

    def get_storage_service() :
        json_path = os.getenv(f"HPDA_GCS_JSON_PATH",gcsaccount)
        os.environ["GOOGLE_APPLICATION_CREDENTIALS"] = json_path
        storage_service = storage.client.Client()
        return storage_service

    try:
        # .config('spark.executor.memory','2g')\
        spark = SparkSession\
            .builder\
            .appName("Python")\
            .config('spark.hadoop.mapreduce.fileoutputcommitter.algorithm.version','2')\
            .getOrCreate()

        sc = spark.sparkContext    

      
        print(f"#| CURVE-count - list_blob - start")
        cli= get_storage_service()
        print(f"#| CURVE-count - list_blob - get_storage_service() - ok")
        bucket = cli.bucket(bucketname)    
        list_all =  list(bucket.list_blobs())  # prefix = blobprefix -- not used
        lasfiles = [ x.name for x in list_all if ".las" in x.name.lower() ]   
        print(f"#| CURVE-count - list_blob - done")

        # --------------- Have to wait for cluster to initialize
        t_0 = time.time()
        t_1 = time.time()
        expected_executor= int(spark.sparkContext.getConf().get("spark.executor.instances"))

        while t_1-t_0 < 1200 :
            nb_executor=  spark.sparkContext._jsc.sc().getExecutorMemoryStatus().size()-1
            print(f"#| study-loader - available executor {nb_executor} /  {expected_executor}")
            if (nb_executor >= expected_executor) :
                print(f"#| study-loader - available executor {nb_executor} >=  {expected_executor} - took {t_1-t_0}s - ok")
                break
            time.sleep(10)  
            t_1 = time.time()

        print(f"number of LAS : {len(lasfiles)}")

        def variable_count(filename):
            try : 
                cli = get_storage_service()   
                bucket = cli.bucket(bucketname)       
                blob = bucket.blob(filename)            
                datastr = blob.download_as_string(client = cli)               
                lf = lasio.read(datastr.decode('latin-1'),ignore_header_errors=True,ignore_data=True)
                return lf.df().columns
            except:
                return ["Error"]
        

        c_count = sc.parallelize(lasfiles[0:500]).flatMap(variable_count).map(lambda x: (x, 1)).reduceByKey(lambda x, y: x + y).collect()

        print(c_count)

    except  Exception as e:
        print(f"#| Curve-count - exception - {e}")
    finally:
        if spark:
            spark.stop()
